/*
 [The "BSD licence"]
 Copyright (c) 2006 Loring Craymer
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.antlr_yggdrasil.runtime;

/**
 * Holds tree codes and arguments.
 * Creation date: (5/21/2005)
 * @author: lgc
 */
public class TreeCodeBlock {
	public static final int LOWER_INVALID = 0;
	public static final int RIGHT = 1;
	public static final int DOWN = 2;
	public static final int ROOT = 4;
	public static final int RIGHTLIST = 33;
	public static final int UP = 8;

	public static final int LIST = 32;
	public static final int NO_CARRIER = 64;
	public static final int REFERENCE = 128;

	private int action = 0;
	private Payload arg = null;

/**
 * TreeCodeBlock constructor.
 * Creation date: (5/21/2005)
 */
public TreeCodeBlock() {
	super();
}

/**
 * TreeCodeBlock constructor.
 * Creation date: (5/21/2005)
 * @param value_ int
 * @param arg_ java.lang.String
 * @param flag_ boolean
 */
	public TreeCodeBlock(int action_, Payload pay) {
		setAction(action_);
		setPayload(pay);
	}

	public void setAction(int op) {
		this.action = op;
	}
	
	public int getAction() {
		return action;
	}
	
	public void setPayload(Payload arg) {
		this.arg = arg;
	}
	
	public Payload getPayload() {
		return arg;
	}
	
	public void assign(int act, Payload data) {
		action = act;
		arg = data;
	}
}